//* $XFree86: xc/include/extensions/shape.h,v 1.3 2001/12/14 19:53:29 dawes Exp $ */
{************************************************************

Copyright 1989, 1998  The Open Group

Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation.

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of The Open Group shall not be
used in advertising or otherwise to promote the sale, use or other dealings
in this Software without prior written authorization from The Open Group.

********************************************************}
unit xshape;

interface

uses ctypes, x, xlib, xutil;

{$packrecords C}

{$linklib Xext}

const
  libxext = 'Xext';

//#include <X11/Xfuncproto.h>

const
  X_ShapeQueryVersion	=	0;
  X_ShapeRectangles	=	1;
  X_ShapeMask		=	2;
  X_ShapeCombine	=	3;
  X_ShapeOffset		=	4;
  X_ShapeQueryExtents	=	5;
  X_ShapeSelectInput	=	6;
  X_ShapeInputSelected	=	7;
  X_ShapeGetRectangles	=	8;

  ShapeSet		=	0;
  ShapeUnion		=	1;
  ShapeIntersect	=	2;
  ShapeSubtract		=	3;
  ShapeInvert		=	4;

  ShapeBounding		=	0;
  ShapeClip		=	1;
  ShapeInput		=	2;

  ShapeNotifyMask	= 1; // (1L << 0);
  ShapeNotify		= 0;

  ShapeNumberEvents	= (ShapeNotify + 1);

//#ifndef _SHAPE_SERVER_

//#include <X11/Xutil.h>

type
  XShapeEvent = record
    type_: cint;      // of event */
    serial: culong;   // # of last request processed by server */
    send_event: cbool;// true if this came frome a SendEvent request */
    display: PDisplay;// Display the event was read from */
    window: TWindow;  // window of event */
    kind: cint;	      // ShapeBounding or ShapeClip */
    x, y: cint;	      // extents of new region */
    width, height: cunsigned;
    time: x.TTime;    // server timestamp when region changed */
    shaped: cbool     // true if the region exists */
  end;

  ctime = cint;

//_XFUNCPROTOBEGIN

function XShapeQueryExtension(
  dpy: PDisplay;        // display
  event_basep: pcint;	// event_base
  error_basep: pcint	// error_base
): cbool; cdecl; external libxext;

function XShapeQueryVersion (
  dpy: PDisplay;	// display
  major_versionp: pcint;// major_version
  minor_versionp: pcint // minor_version
): xlib.TStatus; cdecl; external libxext;

procedure XShapeCombineRegion (
  dpy: PDisplay; // display
  dest: TWindow; // dest
  destKind: cint;// dest_kind
  xOff: cint;    // x_off
  yOff: cint;    // y_off
  r: xutil.TRegion;// region
  op: cint       // op
); cdecl; external libxext;

procedure XShapeCombineRectangles (
  dpy: PDisplay;     // display
  dest: TWindow;     // dest
  destKind: cint;    // dest_kind
  xOff: cint;	     // x_off
  yOff: cint;	     // y_off
  rects: PXRectangle;// rectangles
  n_rects: cint;     // n_rects
  op: cint;	     // op
  ordering: cint     // ordering
); cdecl; external libxext;

procedure XShapeCombineMask (
  dpy: PDisplay; // display
  dest: TWindow; // dest
  destKind: cint;// dest_kind
  xOff: cint;	 // x_off
  yOff: cint;	 // y_off
  src: x.TPixmap;// src
  op: cint 	 // op
); cdecl; external libxext;

procedure XShapeCombineShape (
  dpy: PDisplay; // display
  dest: TWindow; // dest
  destKind: cint;// dest_kind
  xOff: cint;	 // x_off
  yOff: cint;	 // y_off
  src: TWindow;	 // src
  srcKind: cint; // src_kind
  op: cint	 // op
); cdecl; external libxext;

procedure XShapeOffsetShape (
  dpy: PDisplay; // display
  dest: TWindow; // dest
  destKind: cint;// dest_kind
  xOff: cint;	 // x_off
  yOff: cint 	 // y_off
); cdecl; external libxext;

function XShapeQueryExtents (
  dpy: PDisplay;  // display
  window: TWindow;// window
  bShaped: pcbool;// bounding_shaped
  xbs: pcint;	  // x_bounding
  ybs: pcint;	  // y_bounding
  wbs: pcuint;	  // w_bounding
  hbs: pcuint;	  // h_bounding
  cShaped: cbool; // clip_shaped
  xcs: pcint;	  // x_clip
  ycs: pcint;	  // y_clip
  wcs: pcuint;	  // w_clip
  hcs: pcuint	  // h_clip
): xlib.TStatus; cdecl; external libxext;

procedure XShapeSelectInput (
  dpy: PDisplay;  // display
  window: TWindow;// window
  longmask: culong// mask
); cdecl; external libxext;

function XShapeInputSelected (
  dpy: PDisplay;  // display
  window: TWindow // window
): culong; cdecl; external libxext;

function XShapeGetRectangles (
  dpy: PDisplay;  // display
  window: TWindow;// window
  kind: cint;     // kind
  count: pcint;	  // count
  ordering: pcint // ordering
): PXRectangle; cdecl; external libxext;

//_XFUNCPROTOEND

implementation

end.
